/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.persistence.dao;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.wso2.solutions.identity.persistence.HibernateConfig;
import org.wso2.solutions.identity.persistence.dataobject.UserPersonalRelyingPartyDO;

import java.util.List;

public class UserPersonalRelyingPartyDAO extends BaseDAO {

    public UserPersonalRelyingPartyDAO(HibernateConfig config) {
        super(config);
    }

    public UserPersonalRelyingPartyDO[] getAllPersonalRelyingParties(
            String userId) {
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        String stmt = "from UserPersonalRelyingPartyDO as rp where rp.identifier.userId = '"
                + userId + "'";

        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            return (UserPersonalRelyingPartyDO[]) lst
                    .toArray(new UserPersonalRelyingPartyDO[lst.size()]);

        } catch (Throwable e) {
            tx.rollback();
            String msg = messages
                    .getMessage("errorQuerryingUserPersonalRelyingParty");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
    }
    
    public UserPersonalRelyingPartyDO getPersonalRelyingParty(String userId,
            String hostName) {
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        String stmt = "from UserPersonalRelyingPartyDO as rp where rp.identifier.userId = '"
                + userId + "' and rp.identifier.hostName = '" + hostName + "'";

        try {
            Query query = session.createQuery(stmt);
            return (UserPersonalRelyingPartyDO)query.uniqueResult();

        } catch (Throwable e) {
            tx.rollback();
            String msg = messages
                    .getMessage("errorQuerryingUserPersonalRelyingParty");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
    }
    
}
