/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.persistence.dao;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.wso2.solutions.identity.persistence.HibernateConfig;
import org.wso2.solutions.identity.persistence.dataobject.VerifierServiceIdpDO;
import org.wso2.solutions.identity.persistence.dataobject.VerifierServiceRPDO;

import java.util.List;

public class VerifierServiceDAO extends BaseDAO {

    public VerifierServiceDAO(HibernateConfig config) {
        super(config);
        hbConfig = config;
    }

    public VerifierServiceIdpDO[] getAllVerifierServiceIdpDO() {
        String stmt = "from VerifierServiceIdpDO";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        VerifierServiceIdpDO[] array = new VerifierServiceIdpDO[1];
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            array = (VerifierServiceIdpDO[]) lst
                    .toArray(new VerifierServiceIdpDO[lst.size()]);
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages
                    .getMessage("errorQuerryingVerifierServiceData");               
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return array;
    }

    public VerifierServiceRPDO[] getAllVerifierServiceRpDO() {
        String stmt = "from VerifierServiceRPDO";
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        VerifierServiceRPDO[] array = new VerifierServiceRPDO[1];

        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            array = (VerifierServiceRPDO[]) lst
                    .toArray(new VerifierServiceRPDO[lst.size()]);
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages
                    .getMessage("errorQuerryingVerifierServiceData");
            log.error(msg, e);
            throw new RuntimeException(msg, e);
        } finally {
            hbConfig.closeSession();
        }
        return array;
    }

}
